## libatomic-queue 0.0%2Bgit20201108.d9d66b6

=== debian/changelog ===
libatomic-queue (0.0+git20201108.d9d66b6-2) unstable; urgency=high

  * Team upload.
  * Don't build with -m{arch,tune}=native. Closes: #987532
  * debian/rules: build and run upstream's tests
  * Set upstream metadata fields: Repository, Repository-Browse.
  * Add autopkgtests
  * debian/libatomic-queue0.symbols: add missing Build-Depends-Package
    meta-information field
  * debian/control: add missing deps for the -dev package

 -- Michael R. Crusoe <crusoe@debian.org>  Sun, 25 Apr 2021 14:39:37 +0200

libatomic-queue (0.0+git20201108.d9d66b6-1) unstable; urgency=medium

  * New upstream commit
  * Versioned Build-Depends: libxenium-dev (>= 0.0.2+ds-2~)
    Closes: #976481
  * New upstream version
  * Standards-Version: 4.5.1 (routine-update)
  * debhelper-compat 13 (routine-update)
  * Remove trailing whitespace in debian/rules (routine-update)
  * Trim trailing whitespace.
  * Set upstream metadata fields: Bug-Database, Bug-Submit.
  * Remove Section on libatomic-queue0 that duplicates source.

 -- Andreas Tille <tille@debian.org>  Sat, 05 Dec 2020 20:51:05 +0100

libatomic-queue (0.0+git20201007.df79403-2) unstable; urgency=medium

  * Source-only-upload.

 -- Nilesh Patra <npatra974@gmail.com>  Thu, 29 Oct 2020 20:02:48 +0530

libatomic-queue (0.0+git20201007.df79403-1) unstable; urgency=medium

  * Initial release (Closes: #963829)

 -- Andreas Tille <tille@debian.org>  Tue, 27 Oct 2020 08:40:40 +0100

## libatomic-queue 0.0+git20220518.83774a2

=== Makefile ===
# Copyright (c) 2019 Maxim Egorushkin. MIT License. See the full licence in file LICENSE.

# Usage examples (assuming this directory is ~/src/atomic_queue):
# time make -rC ~/src/atomic_queue -j8 run_benchmarks
# time make -rC ~/src/atomic_queue -j8 TOOLSET=clang run_benchmarks
# time make -rC ~/src/atomic_queue -j8 BUILD=debug run_tests

SHELL := /bin/bash
BUILD := release

TOOLSET := gcc
build_dir := ${CURDIR}/build/${BUILD}/${TOOLSET}

cxx.gcc := g++
cc.gcc := gcc
ld.gcc := g++
ar.gcc := gcc-ar

cxx.clang := clang++
cc.clang := clang
ld.clang := clang++
ar.clang := ar

CXX := ${cxx.${TOOLSET}}
CC := ${cc.${TOOLSET}}
LD := ${ld.${TOOLSET}}
AR := ${ar.${TOOLSET}}

cxxflags.gcc.debug := -Og -fstack-protector-all -fno-omit-frame-pointer # -D_GLIBCXX_DEBUG
cxxflags.gcc.release := -O3 -mtune=native -ffast-math -falign-{functions,loops}=64 -DNDEBUG
cxxflags.gcc := -pthread -march=native -std=gnu++14 -W{all,extra,error,no-{maybe-uninitialized,unused-variable,unused-function,unused-local-typedefs}} -g -fmessage-length=0 ${cxxflags.gcc.${BUILD}}

cflags.gcc := -pthread -march=native -W{all,extra} -g -fmessage-length=0 ${cxxflags.gcc.${BUILD}}

cxxflags.clang.debug := -O0 -fstack-protector-all
cxxflags.clang.release := -O3 -mtune=native -ffast-math -falign-functions=64 -DNDEBUG
cxxflags.clang := -stdlib=libstdc++ -pthread -march=native -std=gnu++14 -W{all,extra,error,no-{unused-variable,unused-function,unused-local-typedefs}} -g -fmessage-length=0 ${cxxflags.clang.${BUILD}}
ldflags.clang := -stdlib=libstdc++ ${ldflags.clang.${BUILD}}

# Additional CPPFLAGS, CXXFLAGS, CFLAGS, LDLIBS, LDFLAGS can come from the command line, e.g. make CPPFLAGS='-I<my-include-dir>', or from environment variables.
# However, a clean build is required when changing the flags in the command line or in environment variables, this makefile doesn't detect such changes.
cxxflags := ${cxxflags.${TOOLSET}} ${CXXFLAGS}
cflags := ${cflags.${TOOLSET}} ${CFLAGS}
cppflags := ${CPPFLAGS} -Iinclude
ldflags := -fuse-ld=gold -pthread -g ${ldflags.${TOOLSET}} ${LDFLAGS}
ldlibs := -lrt ${LDLIBS}

cppflags.tbb :=
ldlibs.tbb := {-L,'-Wl,-rpath='}/usr/local/lib -ltbb

cppflags.moodycamel := -I$(abspath ..)
ldlibs.moodycamel :=

cppflags.xenium := -I${abspath ../xenium}
ldlibs.xenium :=

COMPILE.CXX = ${CXX} -o $@ -c ${cppflags} ${cxxflags} -MD -MP $(abspath $<)
COMPILE.S = ${CXX} -o- -S -masm=intel ${cppflags} ${cxxflags} $(abspath $<) | c++filt | egrep -v '^[[:space:]]*\.(loc|cfi|L[A-Z])' > $@
PREPROCESS.CXX = ${CXX} -o $@ -E ${cppflags} ${cxxflags} $(abspath $<)
COMPILE.C = ${CC} -o $@ -c ${cppflags} ${cflags} -MD -MP $(abspath $<)
LINK.EXE = ${LD} -o $@ $(ldflags) $(filter-out Makefile,$^) $(ldlibs)
LINK.SO = ${LD} -o $@ -shared $(ldflags) $(filter-out Makefile,$^) $(ldlibs)
LINK.A = ${AR} rscT $@ $(filter-out Makefile,$^)

exes := benchmarks tests example

all : ${exes}

${exes} : % : ${build_dir}/%
	ln -sf ${<:${CURDIR}/%=%}

benchmarks_src := benchmarks.cc cpu_base_frequency.cc huge_pages.cc
${build_dir}/benchmarks : cppflags += ${cppflags.tbb} ${cppflags.moodycamel} ${cppflags.xenium}
${build_dir}/benchmarks : ldlibs += ${ldlibs.tbb} ${ldlibs.moodycamel} ${ldlibs.xenium} -ldl
${build_dir}/benchmarks : ${benchmarks_src:%.cc=${build_dir}/%.o} Makefile | ${build_dir}
	$(strip ${LINK.EXE})
-include ${benchmarks_src:%.cc=${build_dir}/%.d}

tests_src := tests.cc
${build_dir}/tests : cppflags += ${boost_unit_test_framework_inc} -DBOOST_TEST_DYN_LINK=1
${build_dir}/tests : ldlibs += -lboost_unit_test_framework
${build_dir}/tests : ${tests_src:%.cc=${build_dir}/%.o} Makefile | ${build_dir}
	$(strip ${LINK.EXE})
-include ${tests_src:%.cc=${build_dir}/%.d}

example_src := example.cc
${build_dir}/example : ${example_src:%.cc=${build_dir}/%.o} Makefile | ${build_dir}
	$(strip ${LINK.EXE})
-include ${example_src:%.cc=${build_dir}/%.d}

${build_dir}/%.so : cxxflags += -fPIC
${build_dir}/%.so : Makefile | ${build_dir}
	$(strip ${LINK.SO})

${build_dir}/%.a : Makefile | ${build_dir}
	$(strip ${LINK.A})

run_benchmarks : ${build_dir}/benchmarks
	@echo "---- running $< ----"
	scripts/benchmark-prologue.sh
	-sudo chrt -f 50 $<
	scripts/benchmark-epilogue.sh

run_tests : ${build_dir}/tests
	@echo "---- running $< ----"
	$<

run_% : ${build_dir}/%
	@echo "---- running $< ----"
	$<

${build_dir}/%.o : src/%.cc Makefile | ${build_dir}
	$(strip ${COMPILE.CXX})

${build_dir}/%.o : src/%.c Makefile | ${build_dir}
	$(strip ${COMPILE.C})

%.S : cppflags += ${cppflags.tbb} ${cppflags.moodycamel} ${cppflags.xenium}
%.S : src/%.cc Makefile | ${build_dir}
	$(strip ${COMPILE.S})

%.I : src/%.cc
	$(strip ${PREPROCESS.CXX})

${build_dir} :
	mkdir -p $@

rtags : clean
	${MAKE} -nk all | rtags-rc -c -; true

clean :
	rm -rf ${build_dir} ${exes}

env :
	env | sort --ignore-case

versions:
	${MAKE} --version | head -n1
	${CXX} --version | head -n1

.PHONY : env versions rtags run_benchmarks clean all run_%

=== meson_options.txt ===
option('benchmarks', type : 'boolean', value : true,
       description : 'Do not build benchmarks; ignore their dependencies')

## libatomic-queue 0.0+git20201108.d9d66b6

=== debian/control ===
Source: libatomic-queue
Priority: optional
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Steffen Moeller <moeller@debian.org>,
           Andreas Tille <tille@debian.org>,
           Nilesh Patra <npatra974@gmail.com>
Build-Depends: debhelper-compat (= 13),
               d-shlibs,
               libboost-dev,
               libboost-test-dev,
               libconcurrentqueue-dev,
               libreaderwriterqueue-dev,
               libtbb-dev,
               libxenium-dev (>= 0.0.2+ds-2~)
Standards-Version: 4.5.1
Section: libs
Homepage: https://github.com/max0x7ba/atomic_queue
Vcs-Browser: https://salsa.debian.org/med-team/libatomic-queue
Vcs-Git: https://salsa.debian.org/med-team/libatomic-queue.git
Rules-Requires-Root: no

Package: libatomic-queue0
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: C++ atomic_queue library
 C++11 multiple-producer-multiple-consumer lockless queues based on
 circular buffer with std::atomic.  The main design principle these
 queues follow is simplicity: the bare minimum of atomic operations,
 fixed size buffer, value semantics.
 .
 The circular buffer side-steps the memory reclamation problem inherent
 in linked-list based queues for the price of fixed buffer size. See
 Effective memory reclamation for lock-free data structures in C++
 for more details.
 .
 These qualities are also limitations:
 .
  * The maximum queue size must be set at compile time or construction time.
  * There are no OS-blocking push/pop functions.
 .
 Nevertheless, ultra-low-latency applications need just that and nothing
 more. The simplicity pays off, see the throughput and latency benchmarks.
 .
 Available containers are:
 .
  * AtomicQueue - a fixed size ring-buffer for atomic elements.
  * OptimistAtomicQueue - a faster fixed size ring-buffer for atomic
    elements which busy-waits when empty or full.
  * AtomicQueue2 - a fixed size ring-buffer for non-atomic elements.
  * OptimistAtomicQueue2 - a faster fixed size ring-buffer for non-atomic
    elements which busy-waits when empty or full.
 .
 These containers have corresponding AtomicQueueB, OptimistAtomicQueueB,
 AtomicQueueB2, OptimistAtomicQueueB2 versions where the buffer size is
 specified as an argument to the constructor.
 .
 This package contains the dynamic library.

Package: libatomic-queue-dev
Section: libdevel
Architecture: any
Depends: libatomic-queue0 (= ${binary:Version}),
         ${shlibs:Depends},
         ${misc:Depends}
Description: devel files for C++ atomic_queue library
 C++11 multiple-producer-multiple-consumer lockless queues based on
 circular buffer with std::atomic.  The main design principle these
 queues follow is simplicity: the bare minimum of atomic operations,
 fixed size buffer, value semantics.
 .
 The circular buffer side-steps the memory reclamation problem inherent
 in linked-list based queues for the price of fixed buffer size. See
 Effective memory reclamation for lock-free data structures in C++
 for more details.
 .
 These qualities are also limitations:
 .
  * The maximum queue size must be set at compile time or construction time.
  * There are no OS-blocking push/pop functions.
 .
 Nevertheless, ultra-low-latency applications need just that and nothing
 more. The simplicity pays off, see the throughput and latency benchmarks.
 .
 Available containers are:
 .
  * AtomicQueue - a fixed size ring-buffer for atomic elements.
  * OptimistAtomicQueue - a faster fixed size ring-buffer for atomic
    elements which busy-waits when empty or full.
  * AtomicQueue2 - a fixed size ring-buffer for non-atomic elements.
  * OptimistAtomicQueue2 - a faster fixed size ring-buffer for non-atomic
    elements which busy-waits when empty or full.
 .
 These containers have corresponding AtomicQueueB, OptimistAtomicQueueB,
 AtomicQueueB2, OptimistAtomicQueueB2 versions where the buffer size is
 specified as an argument to the constructor.
 .
 This package contains the header files and static library.

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1


# see FEATURE AREAS in dpkg-buildflags(1)
#export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@

override_dh_install:
	dh_install
	mv `find . -name "*.a"` `dirname $$(find . -name "*.so")`
	d-shlibmove --commit \
		    --multiarch \
		    --devunversioned \
		    --exclude-la \
		    --movedev include usr \
		    $$(find . -name "*.so")

# FIXME: No idea why  dh_strip  fails with
#strip: debian/libatomic-queue-dev/usr/lib/x86_64-linux-gnu/libatomic_queue.a: sorry: copying thin archives is not currently supported: invalid operation
#dh_strip: error: strip --strip-debug --remove-section=.comment --remove-section=.note --enable-deterministic-archives -R .gnu.lto_\* -R .gnu.debuglto_\* -N __gnu_lto_slim -N __gnu_lto_v1 debian/libatomic-queue-dev/usr/lib/x86_64-linux-gnu/libatomic_queue.a returned exit code 1
#dh_strip: error: Aborting due to earlier error
override_dh_strip:
	dh_strip || true

## libatomic-queue 0.0+git20211209.7db4cea

=== debian/changelog ===
libatomic-queue (0.0+git20211209.7db4cea-1) unstable; urgency=medium

  * New upstream version
  * Fix symbols file
    Closes: #1002253
  * Fix lintian override
  * Do not create "thin" ar archives

 -- Andreas Tille <tille@debian.org>  Wed, 22 Dec 2021 06:46:45 +0100

libatomic-queue (0.0+git20201108.d9d66b6-4) unstable; urgency=medium

  * Fix symbols (Closes: #997408)
  * Bump Standards-Version to 4.6.0 (no changes needed)

 -- Nilesh Patra <nilesh@debian.org>  Fri, 29 Oct 2021 19:36:25 +0530

libatomic-queue (0.0+git20201108.d9d66b6-3) unstable; urgency=medium

  * Team upload.

  [ Matthias Klose ]
  * Mark two more symbols as optional. Closes: #989091

  [ Michael R. Crusoe ]
  * Fix lintian-overrides
  * Adjust symbols for gcc-11. Closes: #984084

 -- Michael R. Crusoe <crusoe@debian.org>  Wed, 13 Oct 2021 12:56:34 +0200

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,10 @@
 Source: libatomic-queue
-Priority: optional
 Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
 Uploaders: Steffen Moeller <moeller@debian.org>,
            Andreas Tille <tille@debian.org>,
-           Nilesh Patra <npatra974@gmail.com>
+           Nilesh Patra <nilesh@debian.org>
+Section: libs
+Priority: optional
 Build-Depends: debhelper-compat (= 13),
                d-shlibs,
                libboost-dev,
@@ -11,12 +12,11 @@
                libconcurrentqueue-dev,
                libreaderwriterqueue-dev,
                libtbb-dev,
-               libxenium-dev (>= 0.0.2+ds-2~)
-Standards-Version: 4.5.1
-Section: libs
-Homepage: https://github.com/max0x7ba/atomic_queue
+               libxenium-dev
+Standards-Version: 4.6.0
 Vcs-Browser: https://salsa.debian.org/med-team/libatomic-queue
 Vcs-Git: https://salsa.debian.org/med-team/libatomic-queue.git
+Homepage: https://github.com/max0x7ba/atomic_queue
 Rules-Requires-Root: no
 
 Package: libatomic-queue0
@@ -59,9 +59,10 @@
  This package contains the dynamic library.
 
 Package: libatomic-queue-dev
+Architecture: any
 Section: libdevel
-Architecture: any
 Depends: libatomic-queue0 (= ${binary:Version}),
+         libboost-dev,
          ${shlibs:Depends},
          ${misc:Depends}
 Description: devel files for C++ atomic_queue library

=== debian/watch ===
version=4
opts="mode=git,pretty=0.0+git%cd.%h" \
   https://github.com/max0x7ba/atomic_queue.git HEAD

## libatomic-queue 0.0+git20220518.83774a2

=== debian/changelog ===
libatomic-queue (0.0+git20220518.83774a2-1) unstable; urgency=medium

  * Team upload.

  [ Andreas Tille ]
  * Exclude i386 from Salsa CI since libxenium-dev is not available

  [ Étienne Mollier ]
  * Add compiler.patch: don't erase CC and CXX environment variables.
  * d/s/lintian-overrides: update to new naming convention.
  * d/*.symbols: mark some compiler specific symbols optional.
    (Closes: #1012966)
  * Standards-Version: 4.6.1 (routine-update)

 -- Étienne Mollier <emollier@debian.org>  Fri, 01 Jul 2022 18:36:29 +0200

=== debian/control ===
--- 
+++ 
@@ -13,7 +13,7 @@
                libreaderwriterqueue-dev,
                libtbb-dev,
                libxenium-dev
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Vcs-Browser: https://salsa.debian.org/med-team/libatomic-queue
 Vcs-Git: https://salsa.debian.org/med-team/libatomic-queue.git
 Homepage: https://github.com/max0x7ba/atomic_queue

=== debian/rules ===
--- 
+++ 
@@ -32,3 +32,8 @@
 #dh_strip: error: Aborting due to earlier error
 override_dh_strip:
 	dh_strip || true
+
+override_dh_auto_test:
+ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
+	$(MAKE) example run_tests
+endif

## libatomic-queue 1.4

=== Makefile ===
--- 
+++ 
@@ -4,6 +4,7 @@
 # time make -rC ~/src/atomic_queue -j8 run_benchmarks
 # time make -rC ~/src/atomic_queue -j8 TOOLSET=clang run_benchmarks
 # time make -rC ~/src/atomic_queue -j8 BUILD=debug run_tests
+# time make -rC ~/src/atomic_queue -j8 BUILD=sanitize run_tests
 
 SHELL := /bin/bash
 BUILD := release
@@ -28,13 +29,18 @@
 
 cxxflags.gcc.debug := -Og -fstack-protector-all -fno-omit-frame-pointer # -D_GLIBCXX_DEBUG
 cxxflags.gcc.release := -O3 -mtune=native -ffast-math -falign-{functions,loops}=64 -DNDEBUG
+cxxflags.gcc.sanitize := ${cxxflags.gcc.release} -fsanitize=thread
 cxxflags.gcc := -pthread -march=native -std=gnu++14 -W{all,extra,error,no-{maybe-uninitialized,unused-variable,unused-function,unused-local-typedefs}} -g -fmessage-length=0 ${cxxflags.gcc.${BUILD}}
+ldflags.gcc.sanitize := ${ldflags.gcc.release} -fsanitize=thread
+ldflags.gcc := ${ldflags.gcc.${BUILD}}
 
 cflags.gcc := -pthread -march=native -W{all,extra} -g -fmessage-length=0 ${cxxflags.gcc.${BUILD}}
 
 cxxflags.clang.debug := -O0 -fstack-protector-all
 cxxflags.clang.release := -O3 -mtune=native -ffast-math -falign-functions=64 -DNDEBUG
+cxxflags.clang.sanitize := ${cxxflags.clang.release} -fsanitize=thread
 cxxflags.clang := -stdlib=libstdc++ -pthread -march=native -std=gnu++14 -W{all,extra,error,no-{unused-variable,unused-function,unused-local-typedefs}} -g -fmessage-length=0 ${cxxflags.clang.${BUILD}}
+ldflags.clang.sanitize := ${ldflags.clang.release} -fsanitize=thread
 ldflags.clang := -stdlib=libstdc++ ${ldflags.clang.${BUILD}}
 
 # Additional CPPFLAGS, CXXFLAGS, CFLAGS, LDLIBS, LDFLAGS can come from the command line, e.g. make CPPFLAGS='-I<my-include-dir>', or from environment variables.

=== debian/changelog ===
libatomic-queue (1.4-2) unstable; urgency=medium

  * d/*.symbols: mark several compiler specific symbols as optional.
    (Closes: #1015472, #1075145)
  * d/rules: always run LTO builds.
  * d/control: add myself to uploaders.
  * d/control: declare compliance to standards version 4.7.0.

 -- Étienne Mollier <emollier@debian.org>  Wed, 10 Jul 2024 16:43:27 +0200

libatomic-queue (1.4-1) unstable; urgency=medium

  [ Nilesh Patra ]
  * [ci skip] Remove myself from uploaders

  [ Étienne Mollier ]
  * New upstream version.
  * Standards-Version: 4.6.2 (routine-update)
  * Remove field Section on binary package libatomic-queue0 that duplicates
    source.
  * generate-shared-library.patch: refresh.
  * no-native patch: refresh.
  * no_thin_archives.patch: refresh.
  * compiler.patch: refresh.
  * concurrentqueue.patch: new: fix include issue.
  * d/rules: build with -Wno-error=array-bounds.
    This works around gcc-13 bug [1], also Debian Bug#1041607.
    [1]: https://gcc.gnu.org/bugzilla/show_bug.cgi?id=110764 (Closes: #1037715)
  * d/watch: support tags introduced upstream.

  [ Andreas Tille ]
  * Update symbols

 -- Andreas Tille <tille@debian.org>  Fri, 25 Aug 2023 09:45:57 +0200

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
 Uploaders: Steffen Moeller <moeller@debian.org>,
            Andreas Tille <tille@debian.org>,
-           Nilesh Patra <nilesh@debian.org>
+           Étienne Mollier <emollier@debian.org>
 Section: libs
 Priority: optional
 Build-Depends: debhelper-compat (= 13),
@@ -13,7 +13,7 @@
                libreaderwriterqueue-dev,
                libtbb-dev,
                libxenium-dev
-Standards-Version: 4.6.1
+Standards-Version: 4.7.0
 Vcs-Browser: https://salsa.debian.org/med-team/libatomic-queue
 Vcs-Git: https://salsa.debian.org/med-team/libatomic-queue.git
 Homepage: https://github.com/max0x7ba/atomic_queue

=== debian/rules ===
--- 
+++ 
@@ -1,17 +1,12 @@
 #!/usr/bin/make -f
-# See debhelper(7) (uncomment to enable)
-# output every command that modifies files on the build system.
-#export DH_VERBOSE = 1
+export DEB_BUILD_MAINT_OPTIONS = optimize=+lto
 
+# Workaround gcc-13 bug.  See Gcc bug #110764[1].  FIXME: this is fixed in
+# upcoming upstream build flags[2], so won't be necessary for long.
+# [1]: https://gcc.gnu.org/bugzilla/show_bug.cgi?id=110764
+# [2]: https://github.com/max0x7ba/atomic_queue/commit/c79be00ef12a5f3dc4294ba4954194a712a2853d
+export DEB_CXXFLAGS_MAINT_APPEND  = -Wno-error=array-bounds
 
-# see FEATURE AREAS in dpkg-buildflags(1)
-#export DEB_BUILD_MAINT_OPTIONS = hardening=+all
-
-# see ENVIRONMENT in dpkg-buildflags(1)
-# package maintainers to append CFLAGS
-#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
-# package maintainers to append LDFLAGS
-#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
 
 %:
 	dh $@

## libatomic-queue 1.6.5

=== Makefile ===
# Copyright (c) 2019 Maxim Egorushkin. MIT License. See the full licence in file LICENSE.

# Usage examples (assuming this directory is ~/src/atomic_queue):
#
#   time make -rC ~/src/atomic_queue -j8
#   time make -rC ~/src/atomic_queue -j8 run_benchmarks
#   time make -rC ~/src/atomic_queue -j8 TOOLSET=clang run_benchmarks
#   time make -rC ~/src/atomic_queue -j8 BUILD=debug run_tests
#   time make -rC ~/src/atomic_queue -j8 BUILD=sanitize TOOLSET=clang run_tests
#
# Additional CPPFLAGS, CXXFLAGS, CFLAGS, LDLIBS, LDFLAGS can come from the command line, e.g. make CPPFLAGS='-I<my-include-dir>', or from environment variables.  For example, also produce assembly outputs:
#
#   time make -rC ~/src/atomic_queue -j8 CXXFLAGS="-save-temps=obj -fverbose-asm -masm=intel"
#

SHELL := /bin/bash

BUILD := release
TOOLSET := gcc

build_dir := ${CURDIR}/build/${BUILD}/${TOOLSET}

cxx.gcc := g++
cc.gcc := gcc
ld.gcc := g++
ar.gcc := gcc-ar

cxx.clang := clang++
cc.clang := clang
ld.clang := clang++
ar.clang := ar

CXX := ${cxx.${TOOLSET}}
CC := ${cc.${TOOLSET}}
LD := ${ld.${TOOLSET}}
AR := ${ar.${TOOLSET}}

cxxflags.gcc.debug := -Og -fstack-protector-all -fno-omit-frame-pointer # -D_GLIBCXX_DEBUG
cxxflags.gcc.release := -O3 -mtune=native -ffast-math -falign-{functions,loops}=64 -DNDEBUG
cxxflags.gcc.sanitize := ${cxxflags.gcc.release} -fsanitize=thread
cxxflags.gcc := -pthread -march=native -std=gnu++14 -W{all,extra,error,no-{maybe-uninitialized,unused-variable,unused-function,unused-local-typedefs,error=array-bounds}} -g -fmessage-length=0 ${cxxflags.gcc.${BUILD}}
ldflags.gcc.sanitize := ${ldflags.gcc.release} -fsanitize=thread
ldflags.gcc := ${ldflags.gcc.${BUILD}}

cflags.gcc := -pthread -march=native -W{all,extra} -g -fmessage-length=0 ${cxxflags.gcc.${BUILD}}

cxxflags.clang.debug := -O0 -fstack-protector-all
cxxflags.clang.release := -O3 -mtune=native -ffast-math -falign-functions=64 -DNDEBUG
cxxflags.clang.sanitize := ${cxxflags.clang.release} -fsanitize=thread
cxxflags.clang := -stdlib=libstdc++ -pthread -march=native -std=gnu++14 -W{all,extra,error,no-{unused-variable,unused-function,unused-local-typedefs}} -g -fmessage-length=0 ${cxxflags.clang.${BUILD}}
ldflags.clang.sanitize := ${ldflags.clang.release} -fsanitize=thread
ldflags.clang := -stdlib=libstdc++ ${ldflags.clang.${BUILD}}

# Additional CPPFLAGS, CXXFLAGS, CFLAGS, LDLIBS, LDFLAGS can come from the command line, e.g. make CPPFLAGS='-I<my-include-dir>', or from environment variables.
cxxflags := ${cxxflags.${TOOLSET}} ${CXXFLAGS}
cflags := ${cflags.${TOOLSET}} ${CFLAGS}
cppflags := ${CPPFLAGS} -Iinclude
ldflags := -fuse-ld=gold -pthread -g ${ldflags.${TOOLSET}} ${LDFLAGS}
ldlibs := -lrt ${LDLIBS}

cppflags.tbb :=
ldlibs.tbb := {-L,'-Wl,-rpath='}/usr/local/lib -ltbb

cppflags.moodycamel := -I$(abspath ..)
ldlibs.moodycamel :=

cppflags.xenium := -I${abspath ../xenium}
ldlibs.xenium :=

recompile := ${build_dir}/.make/recompile
relink := ${build_dir}/.make/relink

COMPILE.CXX = ${CXX} -o $@ -c ${cppflags} ${cxxflags} -MD -MP $(abspath $<)
COMPILE.S = ${CXX} -o- -S -fverbose-asm -masm=intel ${cppflags} ${cxxflags} $(abspath $<) | c++filt | egrep -v '^[[:space:]]*\.(loc|cfi|L[A-Z])' > $@
PREPROCESS.CXX = ${CXX} -o $@ -E ${cppflags} ${cxxflags} $(abspath $<)
COMPILE.C = ${CC} -o $@ -c ${cppflags} ${cflags} -MD -MP $(abspath $<)
LINK.EXE = ${LD} -o $@ $(ldflags) $(filter-out ${relink},$^) $(ldlibs)
LINK.SO = ${LD} -o $@ -shared $(ldflags) $(filter-out ${relink},$^) $(ldlibs)
LINK.A = ${AR} rscT $@ $(filter-out ${relink},$^)

ifneq (,$(findstring n,$(firstword -${MAKEFLAGS})))
# Perform bash parameter expansion when --just-print for rtags.
strip2 = $(shell printf '%q ' ${1})
else
# Unduplicate whitespace.
strip2 = $(strip ${1})
endif

exes := benchmarks tests example

all : ${exes}

${exes} : % : ${build_dir}/%
	ln -sf ${<:${CURDIR}/%=%}

benchmarks_src := benchmarks.cc cpu_base_frequency.cc huge_pages.cc
${build_dir}/benchmarks : cppflags += ${cppflags.tbb} ${cppflags.moodycamel} ${cppflags.xenium}
${build_dir}/benchmarks : ldlibs += ${ldlibs.tbb} ${ldlibs.moodycamel} ${ldlibs.xenium} -ldl
${build_dir}/benchmarks : ${benchmarks_src:%.cc=${build_dir}/%.o} ${relink} | ${build_dir}
	$(call strip2,${LINK.EXE})
-include ${benchmarks_src:%.cc=${build_dir}/%.d}

tests_src := tests.cc
${build_dir}/tests : cppflags += -DBOOST_TEST_DYN_LINK=1
${build_dir}/tests : ldlibs += -lboost_unit_test_framework
${build_dir}/tests : ${tests_src:%.cc=${build_dir}/%.o} ${relink} | ${build_dir}
	$(call strip2,${LINK.EXE})
-include ${tests_src:%.cc=${build_dir}/%.d}

example_src := example.cc
${build_dir}/example : ${example_src:%.cc=${build_dir}/%.o} ${relink} | ${build_dir}
	$(call strip2,${LINK.EXE})
-include ${example_src:%.cc=${build_dir}/%.d}

${build_dir}/%.so : cxxflags += -fPIC
${build_dir}/%.so : ${relink} | ${build_dir}
	$(call strip2,${LINK.SO})

${build_dir}/%.a : ${relink} | ${build_dir}
	$(call strip2,${LINK.A})

${build_dir}/%.o : src/%.cc ${recompile} | ${build_dir}
	$(call strip2,${COMPILE.CXX})

${build_dir}/%.o : src/%.c ${recompile} | ${build_dir}
	$(call strip2,${COMPILE.C})

${build_dir}/%.S : cppflags += ${cppflags.tbb} ${cppflags.moodycamel} ${cppflags.xenium}
${build_dir}/%.S : src/%.cc ${recompile} | ${build_dir}
	$(call strip2,${COMPILE.S})

${build_dir}/%.I : cppflags += ${cppflags.tbb} ${cppflags.moodycamel} ${cppflags.xenium}
${build_dir}/%.I : src/%.cc ${recompile} | ${build_dir}
	$(call strip2,${PREPROCESS.CXX})

${build_dir}/%.d : ;

${build_dir}/.make : | ${build_dir}
${build_dir} ${build_dir}/.make:
	mkdir -p $@

ver = "$(shell ${1} --version | head -n1)"
# Trigger recompilation when compiler environment change.
env.compile := $(call ver,${CXX}) ${cppflags} ${cxxflags} ${cppflags.tbb} ${cppflags.moodycamel} ${cppflags.xenium}
# Trigger relink when linker environment change.
env.link := $(call ver,${LD}) ${ldflags} ${ldlibs} ${ldlibs.tbb} ${ldlibs.moodycamel} ${ldlibs.xenium}

define env_txt_rule
${build_dir}/.make/env.${1}.txt : $(shell cmp --quiet ${build_dir}/.make/env.${1}.txt <(printf "%s\n" ${env.${1}}) || echo update_env_txt) Makefile | ${build_dir}/.make
	@printf "%s\n" ${env.${1}} >$$@
endef
$(eval $(call env_txt_rule,compile))
$(eval $(call env_txt_rule,link))
${recompile} ${relink} : ${build_dir}/.make/re% : ${build_dir}/.make/env.%.txt Makefile
	@[[ ! -f $@ ]] || { u="$?"; echo "Re-$* is triggered by changes in $${u// /, }."; }
	touch $@
# cd ~/src/atomic_queue; make -r clean; set -x; make -rj8; make -rj8; make -rj8 CPPFLAGS=-DXYZ=1; make -rj8 CPPFLAGS=-DXYZ=1; make -rj8; make -rj8; make -rj8 LDLIBS=-lrt; make -rj8 LDLIBS=-lrt; make -rj8; make -rj8

run_benchmarks : ${build_dir}/benchmarks
	@echo "---- running $< ----"
	scripts/benchmark-prologue.sh
	-sudo chrt -f 50 $<
	scripts/benchmark-epilogue.sh

run_tests : ${build_dir}/tests
	@echo "---- running $< ----"
	$<

run_% : ${build_dir}/%
	@echo "---- running $< ----"
	$<

rtags :
	${MAKE} --always-make --just-print all | { rtags-rc -c -; true; }

clean :
	rm -rf ${build_dir} ${exes}

versions:
	${MAKE} --version | awk 'FNR<2'
	${CXX} --version | head -n1

env :
	env | sort --ignore-case

.PHONY : update_env_txt env versions rtags run_benchmarks clean all run_%

=== debian/changelog ===
libatomic-queue (1.6.5-2) unstable; urgency=medium

  * d/control: build depends on binutils-gold to pull ld.gold.
    (Closes: #1096216)
  * d/control: declare compliance to standards version 4.7.1.
  * d/patches/*: normalize Last-Update timestamp against dep3.

 -- Étienne Mollier <emollier@debian.org>  Tue, 25 Feb 2025 23:31:15 +0100

libatomic-queue (1.6.5-1) unstable; urgency=medium

  * New upstream version 1.6.5

 -- Étienne Mollier <emollier@debian.org>  Wed, 02 Oct 2024 21:08:56 +0200

libatomic-queue (1.6.4-1) unstable; urgency=medium

  * New upstream version 1.6.4
  * generate-shared-library.patch: refresh.
  * no-native: refresh patch.
  * no_thin_archives.patch: refresh.
  * compiler.patch: unfuzz.
  * fix_unused_variable.patch: unfuzz.
  * d/rules: remove workaround for gcc 13 bug.
  * d/rules: remove workaround against dh_strip failure.
  * d/rules: delete file landing in standard top directory.
  * d/control: deduplicate Section: libs field.
  * d/s/lintian-overrides: flag another source-missing false positive.

 -- Étienne Mollier <emollier@debian.org>  Fri, 23 Aug 2024 13:20:22 +0200

=== debian/control ===
--- 
+++ 
@@ -6,6 +6,7 @@
 Section: libs
 Priority: optional
 Build-Depends: debhelper-compat (= 13),
+               binutils-gold,
                d-shlibs,
                libboost-dev,
                libboost-test-dev,
@@ -13,7 +14,7 @@
                libreaderwriterqueue-dev,
                libtbb-dev,
                libxenium-dev
-Standards-Version: 4.7.0
+Standards-Version: 4.7.1
 Vcs-Browser: https://salsa.debian.org/med-team/libatomic-queue
 Vcs-Git: https://salsa.debian.org/med-team/libatomic-queue.git
 Homepage: https://github.com/max0x7ba/atomic_queue
@@ -21,7 +22,6 @@
 
 Package: libatomic-queue0
 Architecture: any
-Section: libs
 Depends: ${shlibs:Depends},
          ${misc:Depends}
 Description: C++ atomic_queue library

=== debian/rules ===
#!/usr/bin/make -f
export DEB_BUILD_MAINT_OPTIONS = optimize=+lto

%:
	dh $@

override_dh_install:
	dh_install
	mv `find . -name "*.a"` `dirname $$(find . -name "*.so")`
	d-shlibmove --commit \
		    --multiarch \
		    --devunversioned \
		    --exclude-la \
		    --movedev include usr \
		    $$(find . -name "*.so")
	rm -vf debian/libatomic-queue-dev/usr/include/CMakeLists.txt

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	$(MAKE) example run_tests
endif

=== debian/tests/control ===
Tests: run-unit-test
Depends: libatomic-queue-dev, libboost-test-dev, g++
Restrictions: allow-stderr

## libatomic-queue 1.6.9

=== Makefile ===
--- 
+++ 
@@ -38,23 +38,24 @@
 cxxflags.gcc.debug := -Og -fstack-protector-all -fno-omit-frame-pointer # -D_GLIBCXX_DEBUG
 cxxflags.gcc.release := -O3 -mtune=native -ffast-math -falign-{functions,loops}=64 -DNDEBUG
 cxxflags.gcc.sanitize := ${cxxflags.gcc.release} -fsanitize=thread
-cxxflags.gcc := -pthread -march=native -std=gnu++14 -W{all,extra,error,no-{maybe-uninitialized,unused-variable,unused-function,unused-local-typedefs,error=array-bounds}} -g -fmessage-length=0 ${cxxflags.gcc.${BUILD}}
+cxxflags.gcc := -std=gnu++14 -pthread -march=native -W{all,extra,error,no-{array-bounds,maybe-uninitialized,unused-variable,unused-function,unused-local-typedefs}} -fmessage-length=0 ${cxxflags.gcc.${BUILD}}
 ldflags.gcc.sanitize := ${ldflags.gcc.release} -fsanitize=thread
 ldflags.gcc := ${ldflags.gcc.${BUILD}}
 
-cflags.gcc := -pthread -march=native -W{all,extra} -g -fmessage-length=0 ${cxxflags.gcc.${BUILD}}
+cflags.gcc := -pthread -march=native -W{all,extra} -fmessage-length=0 ${cxxflags.gcc.${BUILD}}
 
 cxxflags.clang.debug := -O0 -fstack-protector-all
 cxxflags.clang.release := -O3 -mtune=native -ffast-math -falign-functions=64 -DNDEBUG
 cxxflags.clang.sanitize := ${cxxflags.clang.release} -fsanitize=thread
-cxxflags.clang := -stdlib=libstdc++ -pthread -march=native -std=gnu++14 -W{all,extra,error,no-{unused-variable,unused-function,unused-local-typedefs}} -g -fmessage-length=0 ${cxxflags.clang.${BUILD}}
+cxxflags.clang := -std=gnu++14 -pthread -march=native -stdlib=libstdc++ -W{all,extra,error,no-{unused-variable,unused-function,unused-local-typedefs}} -fmessage-length=0 ${cxxflags.clang.${BUILD}}
 ldflags.clang.sanitize := ${ldflags.clang.release} -fsanitize=thread
+ldflags.clang.debug := -latomic
 ldflags.clang := -stdlib=libstdc++ ${ldflags.clang.${BUILD}}
 
 # Additional CPPFLAGS, CXXFLAGS, CFLAGS, LDLIBS, LDFLAGS can come from the command line, e.g. make CPPFLAGS='-I<my-include-dir>', or from environment variables.
-cxxflags := ${cxxflags.${TOOLSET}} ${CXXFLAGS}
-cflags := ${cflags.${TOOLSET}} ${CFLAGS}
-cppflags := ${CPPFLAGS} -Iinclude
+cxxflags := ${cxxflags.${TOOLSET}} -g ${CXXFLAGS}
+cflags := ${cflags.${TOOLSET}} -g ${CFLAGS}
+cppflags := -Iinclude ${CPPFLAGS}
 ldflags := -fuse-ld=gold -pthread -g ${ldflags.${TOOLSET}} ${LDFLAGS}
 ldlibs := -lrt ${LDLIBS}
 
@@ -65,14 +66,13 @@
 ldlibs.moodycamel :=
 
 cppflags.xenium := -I${abspath ../xenium}
+cxxflags.xenium := -std=gnu++17
 ldlibs.xenium :=
 
 recompile := ${build_dir}/.make/recompile
 relink := ${build_dir}/.make/relink
 
 COMPILE.CXX = ${CXX} -o $@ -c ${cppflags} ${cxxflags} -MD -MP $(abspath $<)
-COMPILE.S = ${CXX} -o- -S -fverbose-asm -masm=intel ${cppflags} ${cxxflags} $(abspath $<) | c++filt | egrep -v '^[[:space:]]*\.(loc|cfi|L[A-Z])' > $@
-PREPROCESS.CXX = ${CXX} -o $@ -E ${cppflags} ${cxxflags} $(abspath $<)
 COMPILE.C = ${CC} -o $@ -c ${cppflags} ${cflags} -MD -MP $(abspath $<)
 LINK.EXE = ${LD} -o $@ $(ldflags) $(filter-out ${relink},$^) $(ldlibs)
 LINK.SO = ${LD} -o $@ -shared $(ldflags) $(filter-out ${relink},$^) $(ldlibs)
@@ -86,15 +86,17 @@
 strip2 = $(strip ${1})
 endif
 
+#
+# Build targets definitions begin.
+#
+
 exes := benchmarks tests example
 
 all : ${exes}
 
-${exes} : % : ${build_dir}/%
-	ln -sf ${<:${CURDIR}/%=%}
-
 benchmarks_src := benchmarks.cc cpu_base_frequency.cc huge_pages.cc
 ${build_dir}/benchmarks : cppflags += ${cppflags.tbb} ${cppflags.moodycamel} ${cppflags.xenium}
+${build_dir}/benchmarks : cxxflags += ${cxxflags.tbb} ${cxxflags.moodycamel} ${cxxflags.xenium}
 ${build_dir}/benchmarks : ldlibs += ${ldlibs.tbb} ${ldlibs.moodycamel} ${ldlibs.xenium} -ldl
 ${build_dir}/benchmarks : ${benchmarks_src:%.cc=${build_dir}/%.o} ${relink} | ${build_dir}
 	$(call strip2,${LINK.EXE})
@@ -112,6 +114,13 @@
 	$(call strip2,${LINK.EXE})
 -include ${example_src:%.cc=${build_dir}/%.d}
 
+#
+# Build targets definitions end.
+#
+
+${exes} : % : ${build_dir}/%
+	ln -sf ${<:${CURDIR}/%=%}
+
 ${build_dir}/%.so : cxxflags += -fPIC
 ${build_dir}/%.so : ${relink} | ${build_dir}
 	$(call strip2,${LINK.SO})
@@ -125,14 +134,6 @@
 ${build_dir}/%.o : src/%.c ${recompile} | ${build_dir}
 	$(call strip2,${COMPILE.C})
 
-${build_dir}/%.S : cppflags += ${cppflags.tbb} ${cppflags.moodycamel} ${cppflags.xenium}
-${build_dir}/%.S : src/%.cc ${recompile} | ${build_dir}
-	$(call strip2,${COMPILE.S})
-
-${build_dir}/%.I : cppflags += ${cppflags.tbb} ${cppflags.moodycamel} ${cppflags.xenium}
-${build_dir}/%.I : src/%.cc ${recompile} | ${build_dir}
-	$(call strip2,${PREPROCESS.CXX})
-
 ${build_dir}/%.d : ;
 
 ${build_dir}/.make : | ${build_dir}
@@ -141,7 +142,7 @@
 
 ver = "$(shell ${1} --version | head -n1)"
 # Trigger recompilation when compiler environment change.
-env.compile := $(call ver,${CXX}) ${cppflags} ${cxxflags} ${cppflags.tbb} ${cppflags.moodycamel} ${cppflags.xenium}
+env.compile := $(call ver,${CXX}) ${cppflags} ${cxxflags} ${cppflags.tbb} ${cppflags.moodycamel} ${cppflags.xenium} ${cxxflags.tbb} ${cxxflags.moodycamel} ${cxxflags.xenium}
 # Trigger relink when linker environment change.
 env.link := $(call ver,${LD}) ${ldflags} ${ldlibs} ${ldlibs.tbb} ${ldlibs.moodycamel} ${ldlibs.xenium}
 
@@ -174,7 +175,7 @@
 	${MAKE} --always-make --just-print all | { rtags-rc -c -; true; }
 
 clean :
-	rm -rf ${build_dir} ${exes}
+	rm -rf ${exes} ${build_dir}
 
 versions:
 	${MAKE} --version | awk 'FNR<2'
@@ -184,3 +185,10 @@
 	env | sort --ignore-case
 
 .PHONY : update_env_txt env versions rtags run_benchmarks clean all run_%
+.DELETE_ON_ERROR:
+.SECONDARY:
+.SUFFIXES:
+
+# Local Variables:
+# compile-command: "/bin/time make -rC ~/src/atomic_queue -j$(($(nproc)/2)) BUILD=debug run_tests"
+# End:

=== debian/changelog ===
libatomic-queue (1.6.9-1) experimental; urgency=medium

  * New upstream version 1.6.9
  * d/control: declare compliance to standards version 4.7.2.
  * Use meson for installation, removes libatomic-queue0. (Closes: #1104583)

 -- Stephan Lachnit <stephanlachnit@debian.org>  Tue, 24 Jun 2025 20:31:53 +0200

## libatomic-queue 1.7.1

=== CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED( VERSION 3.25 )

PROJECT(atomic_queue VERSION 1.5.0)

OPTION( ATOMIC_QUEUE_BUILD_TESTS
    "If the tests should be built."
    OFF
)

OPTION( ATOMIC_QUEUE_BUILD_EXAMPLES
    "If examples should be built."
    OFF
)

if ( PROJECT_IS_TOP_LEVEL )
    set(CMAKE_CXX_STANDARD 14)
    set(CMAKE_CXX_STANDARD_REQUIRED)
endif()

add_subdirectory( include )

if ( ATOMIC_QUEUE_BUILD_TESTS )
    enable_testing()
endif()

if ( ATOMIC_QUEUE_BUILD_TESTS OR ATOMIC_QUEUE_BUILD_EXAMPLES)
    add_subdirectory( src )
endif()

add_library(max0x7ba::atomic_queue ALIAS atomic_queue)

=== Makefile ===
--- 
+++ 
@@ -165,7 +165,7 @@
 
 run_tests : ${build_dir}/tests
 	@echo "---- running $< ----"
-	$<
+	$< --log_level=warning
 
 run_% : ${build_dir}/%
 	@echo "---- running $< ----"

=== meson_options.txt ===
option('benchmarks', type : 'boolean', value : false,
       description : 'Build benchmarks (requires Boost, TBB, Xenium, moodycamel and C++17)')
option('tests', type : 'boolean', value : true,
       description : 'Build tests and example (requires Boost)')

=== include/CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED( VERSION 3.25 )

add_library(
    atomic_queue
    INTERFACE
    ${CMAKE_CURRENT_SOURCE_DIR}/atomic_queue/atomic_queue.h
    ${CMAKE_CURRENT_SOURCE_DIR}/atomic_queue/atomic_queue_mutex.h
    ${CMAKE_CURRENT_SOURCE_DIR}/atomic_queue/barrier.h
    ${CMAKE_CURRENT_SOURCE_DIR}/atomic_queue/defs.h
    ${CMAKE_CURRENT_SOURCE_DIR}/atomic_queue/spinlock.h
)

target_include_directories(
    atomic_queue
    INTERFACE
    ${CMAKE_CURRENT_SOURCE_DIR}
)

=== src/CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED( VERSION 3.25 )

if ( ATOMIC_QUEUE_BUILD_EXAMPLES )
    add_executable(
        atomic_queue_example
        ${CMAKE_CURRENT_SOURCE_DIR}/example.cc
    )

    target_link_libraries(
        atomic_queue_example
        atomic_queue
    )
endif()

if ( ATOMIC_QUEUE_BUILD_TESTS )
    find_package(Boost REQUIRED COMPONENTS unit_test_framework)

    add_executable(
        atomic_queue_tests
        ${CMAKE_CURRENT_SOURCE_DIR}/tests.cc
    )

    target_link_libraries(
        atomic_queue_tests
        atomic_queue
        Boost::unit_test_framework
    )

    add_test(
        NAME atomic_queue_tests
        COMMAND atomic_queue_tests
    )
endif()

=== debian/changelog ===
libatomic-queue (1.7.1-1) unstable; urgency=medium

  * New upstream version 1.7.1

 -- Stephan Lachnit <stephanlachnit@debian.org>  Fri, 22 Aug 2025 11:38:23 +0200

=== debian/control ===
Source: libatomic-queue
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Steffen Moeller <moeller@debian.org>,
           Andreas Tille <tille@debian.org>,
           Étienne Mollier <emollier@debian.org>,
           Stephan Lachnit <stephanlachnit@debian.org>,
Section: libs
Priority: optional
Build-Depends: debhelper-compat (= 13),
               meson,
               libboost-test-dev,
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/med-team/libatomic-queue
Vcs-Git: https://salsa.debian.org/med-team/libatomic-queue.git
Homepage: https://github.com/max0x7ba/atomic_queue
Rules-Requires-Root: no

Package: libatomic-queue-dev
Architecture: any
Section: libdevel
Depends: ${shlibs:Depends},
         ${misc:Depends},
Description: devel files for C++ atomic_queue library
 C++11 multiple-producer-multiple-consumer lockless queues based on
 circular buffer with std::atomic.  The main design principle these
 queues follow is simplicity: the bare minimum of atomic operations,
 fixed size buffer, value semantics.
 .
 The circular buffer side-steps the memory reclamation problem inherent
 in linked-list based queues for the price of fixed buffer size. See
 Effective memory reclamation for lock-free data structures in C++
 for more details.
 .
 These qualities are also limitations:
 .
  * The maximum queue size must be set at compile time or construction time.
  * There are no OS-blocking push/pop functions.
 .
 Nevertheless, ultra-low-latency applications need just that and nothing
 more. The simplicity pays off, see the throughput and latency benchmarks.
 .
 Available containers are:
 .
  * AtomicQueue - a fixed size ring-buffer for atomic elements.
  * OptimistAtomicQueue - a faster fixed size ring-buffer for atomic
    elements which busy-waits when empty or full.
  * AtomicQueue2 - a fixed size ring-buffer for non-atomic elements.
  * OptimistAtomicQueue2 - a faster fixed size ring-buffer for non-atomic
    elements which busy-waits when empty or full.
 .
 These containers have corresponding AtomicQueueB, OptimistAtomicQueueB,
 AtomicQueueB2, OptimistAtomicQueueB2 versions where the buffer size is
 specified as an argument to the constructor.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ -Smeson

=== debian/tests/control ===
Tests: run-unit-test
Depends: g++, meson, pkgconf, libatomic-queue-dev, libboost-test-dev

=== debian/watch ===
version=4
opts="mode=git,dversionmangle=auto" \
https://github.com/max0x7ba/atomic_queue.git \
refs/tags/v?([\d\.\d]+)
